; ROUTINE TO CREATE A FILE
;
;  Function:
;       Creates a file for read/write. If a file exists it is truncated.
;  Input:
;       On entry DS:DX points to an ASCIIZ string. Drive path & filename.
;  Output:
;       If file is opened; carry is clear, handle is in AX
;       If file is not opened; carry is set, error code is in AX
; Registers used:
;       AX is modified; DX is used for input
; Routines used:
;       DOS call 3Ch(CREAT)
;
createfile      proc    far
;
        push    cx              ; save register
;
        mov     cx,0            ; attribute 0
        mov     ah,3Ch          ; create file
        int     21h             ; DOS call
;
        pop     cx              ; restore register
        ret
;
createfile      endp
;


