; ROUTINE TO MAKE GLISSANDO
;
glissando       proc    far
;
        push    si
        push    dx              ;save registers
        push    cx
        push    bx
        push    ax
;
        mov     x1,bx           ; lower limit of frequencies
        mov     x2,cx           ; upper limit of frequencies
;
        call    toneon          ; turn on tone
;
; set up loop parameters
        mov     si,1            ; increment for loop
        cmp     bx,cx           ; up or down ?
        jle     gliss1          ; skip if up
;
        neg     si              ; decrement freq in the loop
;
gliss1:
        mov     cx,bx           ; get the frequency
        call    freq            ; convert to clock cycles
        call    toneset         ; set the tone
        mov     cx,dx           ; delay parameter
gliss2:
        loop    gliss2
;
        cmp     bx,x2           ; check if done
        je      gliss3          ; exit if so
        add     bx,si           ; update the frequency
;
        jmp     gliss1
;
gliss3:
; turn off the tone
        call    toneoff         ; turn it off
;
        pop     ax              ; restore registers
        pop     bx
        pop     cx
        pop     dx
        pop     si
        ret
;
glissando       endp

