; ROUTINE TO CONVERT FROM INTERNAL 16-BIT BINARY TO INTERNAL BCD
;
i162bcd proc    far
;
        push    ds             ; save registers
        push    di
        push    dx
        push    cx
        push    ax
;
; set up data segment
        mov     ax,datas       ; point to data segment
        mov     ds,ax
;
; a binary number is in DX
;
; clear bcd buffer
        lea     di,bcdbuff      ; point to buffer
        mov     al,0            ; zero byte
        mov     cx,18           ; buffer size
i162bcd1:
        mov     [di],al         ; clear the byte
        inc     di              ; next byte
        loop    i162bcd1
;
; put the digits in a buffer
        lea     di,bcdbuff      ; point to buffer
i162bcd2:
        mov     ax,dx           ; numerator
        mov     dx,0            ; clear upper half
        mov     cx,10           ; divisor of 10
        div     cx              ; divide
        xchg    ax,dx           ; get quotient
        mov     bl,al           ; save digit
;
        mov     ax,dx           ; numerator
        mov     dx,0            ; clear upper half
        mov     cx,10           ; divisor of 10
        div     cx              ; divide
        xchg    ax,dx           ; get quotient
;
        mov     cl,4            ; for a count of 4
        rol     al,cl           ; rotate digit
        and     al,0F0h         ; just the digit
        or      al,bl           ; combine digits
;
        mov     [di],al         ; put in buffer
        inc     di              ; next byte
        cmp     dx,0            ; done?
        jnz     i162bcd2
;
         pop     ax             ; restore registers
         pop     cx
         pop     dx
         pop     di
         pop     ds
         ret                    ; return
;
i162bcd  endp
