; ROUTINE TO INITIALIZE CIRCULAR INPUT BUFFER
;
;  Function:
;       Intializes pointers and control variables for a circular buffer
;  Output:
;       Registers SI & DI are set to zero.
;       Variables GAUGE & LASTBYTE are set to zero.
;  Segments referenced:
;       On entry the data segment must contain the circular buffer and
;       the variables CBUFF, GAUGE, & LASTBYTE
;
initcbuff       proc    far
        mov     si,0            ; initialize SI
        mov     di,0            ; initialize DI
        mov     guage,0         ; and number of bytes in buffer
        mov     lastbyte,0      ; also last byte buffer
;
        ret
;
initcbuff       endp
;

