;ROUTINE TO CLEAR THE GRAPHICS SCREEN
; Function: clears the color graphic screen
; Segments referenced: Upon entry ES must point to the screen RAM
; at B8000h
;
; page 130 " Bluebook of assembly routines for the ibm pc "
;
;
cls     proc    far
;
        push    cx              ; save registers
        push    ax
;
; set up the registers
        mov     cx,2000h        ; word count of the whole screen
        mov     ax,0            ; zero pattern for the screen
        mov     di,ax           ; set starting address
        cld                     ; go in forward direction
;
; clear the screen with a single string operation
        rep     stosw           ; this clears the screen
;
        pop     ax              ; restore the registers
        pop     cx
        ret
cls     endp


