; ROUTINE TO CONVERT FROM INTERNAL INTEGER TO INTERNAL FLOATING POINT
;
float   proc    far
;
; the number is in DX
;
        push    dx              ; save registers
        push    cx
        pusht   ax
;
        mov     ax,0            ; extend to 32 bits
        cmp     dx,0            ; check fi zero
        jz      float4
;
float1:
        mov     cx,9800h        ; initialize exponent and sign
; shift left until normalized
float2:
        test    ax,0080h        ; done yet?
        jnz     float3          ; exit if so
        sal     dx,1            ; shift all bits left if not
        rcl     ax,1            ; carry on
        dec     ch              ; decrement the exponent
        jmp     float2
;
float3:
;
; pack it in
        and     ax,007Fh        ; just the mantissa
        or      ax,cx           ; exponent and sign
;
float4:
        mov     sfpbuffw0,dx    ; put lower part into place
        mov     sfpbuffw2,ax    ; put upper part into place
;
; show hex for debugging
        lea     si,internal     ; point to message
        call    stdmessout      ; send message
;
        mov     dx,sfpbuffw2    ; upper word
        call    hex16out        ; show it
;
        mov     dx,sfpbuffw0    ; lower word
        call    hex16out        ; show it
;
        call    stdspace        ; skip space
;
;
        pop     ax              ; restore registers
        pop     cx
        pop     dx
        ret                     ; return
;
float   endp
