; ROUTINE TO PRINT A MESSAGE ON THE GRAPHICS SCREEN
;
gmessout        proc    far
;
; get (x,y) location of message on the screen
        mov     ax,xmess        ; get x-coordinate on screen
        mov     x0,ax           ; for first character
        mov     ax,ymess        ; get y-coordinate on screen
        mov     y0,ax           ; for first character
        cld                     ; go in forward direction
;
; main loop through characters of the message
gmessloop:
        cld                     ; forward direction
        lodsb                   ; get the ASCII code
        cmp     a1,0            ; end of string?
        je      gmessexit
;
; check for fonts
font0:
        cmp     font,0          ; use font 0?
        jne     font1
        call    schar           ; stroke characters
;
font1:
        cmp     font1           ; use font 1?
        jne     nextchar
        call    rchar           ; raster characters
;
nextchar:
        mov     al,8            ; character cell width
        mov     cl,xmagn        ; times horizontal magnitude
        mul     cl              ; multiply
        add     x0,ax           ; add to location of previous char
;
        jmp     gmessloop       ; loop for next character
;
gmessexit:
        ret
gmessout        endp


