; ROUTINE TO SWITCH TWO STRINGS
;
; Input:
;       DS:SI points to the source, DS:DI the destination.
;       CX has length of strings
; Output:
;       On exit the strings are switched
; Registers used:
;       No register is modified
; Segments referenced:
;       On entry data segment contains source
;       and extra segment contains destination.
;
switch  proc    far
;
        push    si              ; save registers
        push    di
        push    cx
        push    ax
;
        cld                     ; forward direction
switch1
        mov     al,[dl]         ; get byte from destination
        movsb                   ; move from source to destination
        mov     es:[si-1],al    ; put byte in source
        loop    switch1         ; loop back for more
;
        pop     ax              ; restore registers
        pop     cx
        pop     di
        pop     si
        ret
;
switch  endp
;
;
